commit 5210f05c6eba12561914cb0fdf7aec149b28f179
Author: Segher Boessenkool <segher@kernel.crashing.org>
Date:   Thu Sep 2 18:38:24 2021

    rs6000: Don't use r12 for CR save on ELFv2 (PR102107)
    
    CR is saved and/or restored on some paths where GPR12 is already live
    since it has a meaning in the calling convention in the ELFv2 ABI.
    
    It is not completely clear to me that we can always use r11 here, but
    it does seem save, there is checking code (to detect conflicts here),
    and it is stage 1.  So here goes.
    
    2021-09-03  Segher Boessenkool <segher@kernel.crashing.org>
    
            PR target/102107
            * config/rs6000/rs6000-logue.c (rs6000_emit_prologue): On ELFv2 use r11
            instead of r12 for CR save, in all cases.
    
    (cherry picked from commit 2484f7a4b0f52e6ed04754be336f1fa6fde47f6b)

diff --git a/gcc/config/rs6000/rs6000-logue.c b/gcc/config/rs6000/rs6000-logue.c
index 07337c4836a..e363d56ecec 100644
--- a/gcc/config/rs6000/rs6000-logue.c
+++ b/gcc/config/rs6000/rs6000-logue.c
@@ -3293,10 +3293,13 @@ rs6000_emit_prologue (void)
 
   /* If we need to save CR, put it into r12 or r11.  Choose r12 except when
      r12 will be needed by out-of-line gpr save.  */
-  cr_save_regno = ((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
-		   && !(strategy & (SAVE_INLINE_GPRS
-				    | SAVE_NOINLINE_GPRS_SAVES_LR))
-		   ? 11 : 12);
+  if (DEFAULT_ABI == ABI_AIX
+      && !(strategy & (SAVE_INLINE_GPRS | SAVE_NOINLINE_GPRS_SAVES_LR)))
+    cr_save_regno = 11;
+  else if (DEFAULT_ABI == ABI_ELFv2)
+    cr_save_regno = 11;
+  else
+    cr_save_regno = 12;
   if (!WORLD_SAVE_P (info)
       && info->cr_save_p
       && REGNO (frame_reg_rtx) != cr_save_regno

